import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;

public class DwHelp extends FormComponent {
	protected Image				off_image			=	null;

	protected Image				list_title_img		=	null;
	protected Image				bottom_img		=	null;

	protected String				title				=	null;
	protected String[]				button_text		=	null;

	protected _TextBoxComponent		tbc				=	null;
	protected int					rgb_color			=	0x000000;

	public DwHelp() {
		this.title		=	"";
		this.button_text	=	new String[] { "", " " };

		String text		=	" \n" +
						" α׷  ˻ϴ α׷Դϴ.\n" +
						"˻ Ͻô (  ) ԷϽð ˻ Ͻø    ֽϴ.\n" +
						"copyright  CYMENT CM\n" +
						"http://www.cyment.co.kr\n" +
						"02-538-8116";

		tbc	=	new _TextBoxComponent(text, TextComponent.CONSTRAINT_ANY);
		addComponent(tbc);
		
		loadImage();
	}

	/**
	 * Layout Ѵ.
	 */
	public void layout() {
		tbc.setBounds(4, 20, getWidth() - 8, getHeight() - 47);
	}

	/**
	 * ̹ ε...
	 */
	protected void loadImage() {
		try {
			list_title_img	=	Image.createImage("list_title.png");
			bottom_img	=	Image.createImage("bottom.png");

		} catch (Exception e) {
			DwCommon.Debug(e);
		}
	}

	/**
	 * TextBox Data 
	 */
	public void setData(String content) {
		tbc.setString(content);
		tbc.insert(new char[] { }, 0, 0, 0);
		
		repaint();
	}

	/**
	 * TextBox ڻ 
	 */
	public void setColor(int rgb_color) {
		tbc.setForeground(rgb_color);
	}

	/**
	 * Component paintƾ...
	 * ӵ  ؼ bufferd image Ѵ.
	 */
	public void paintContent(Graphics g) {
		try {
			if(off_image == null) {
				off_image	=	Image.createImage(getWidth(), getHeight());
			}
			
			if(off_image != null) {
				Graphics gc	=	off_image.getGraphics();

				gc.setColor(0xffffff);
				gc.fillRect(0, 0, getWidth(), getHeight());

				drawList(gc);

				g.drawImage(off_image, 0, 0, g.TOP | g.LEFT);
				
			}
		} catch (Exception e) {
			DwCommon.Debug(e);
		}
		
		tbc.setFocus();
	}

	public void setFocus() {
		tbc.setFocus();
	}

	/**
	 * Ʈ  ư ׸...
	 */
	public void drawList(Graphics g) {
		// ȭ ʺκп η ϴû  draw
		g.setColor(0xcdddf5);
		g.fillRect(0, 0, getWidth(), getHeight());

		// ŸƲ ̹ draw
		g.drawImage(list_title_img, 0, 0, g.TOP | g.LEFT);

		// Font  ó...
		Font old_font	=	g.getFont();
		Font new_font	=	Font.getFont(old_font.getFace(), Font.STYLE_BOLD, old_font.getSize());
		g.setFont(new_font);

		// ŸƲٿ  ǥ...
		g.setColor(0xffffff);
		g.drawString(title, 15, 1, g.TOP | g.LEFT);

		int bottom_img_y	=	getHeight() - bottom_img.getHeight();

		// ȭ Ʒ ư draw
		g.drawImage(bottom_img, 0, bottom_img_y, g.TOP | g.LEFT);

		g.setFont(new_font);
		g.setColor(0xffffff);

		// ư draw
		if(button_text != null && button_text.length > 0) {
			g.drawString(button_text[0], (40 - old_font.stringWidth(button_text[0])) / 2, bottom_img_y + 5, g.TOP | g.LEFT);

			if(button_text.length == 2) {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			} else {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40, bottom_img_y + 5, g.TOP | g.LEFT);
				g.drawString(button_text[2], (40 - old_font.stringWidth(button_text[2])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			}
		}

	}

	/**
	 * Ű ̺Ʈ ó...
	 */
	public boolean keyNotify(int type, int key) {
		if(type == EventQueue.KEY_PRESSED) {
			switch(Display.getGameAction(key)) {

				case EventQueue.SOFT1 :
					break;

				case EventQueue.FIRE :
					break;

				case EventQueue.SOFT2 :
					// Ʈ ȭ ̵ ̵
					DwData.input_field.setText("");
					DwData.showComponent(DwData.input_field);
					break;
			}
		}

		repaint();
		return false;
	}
	
	public class _TextBoxComponent extends TextBoxComponent {
		public _TextBoxComponent(String data, int constraints) {
			super(data, constraints);
		}

		public void setBounds(int x, int y, int width, int height) {
			this.x	=	x;
			this.y	=	y;
			this.w	=	width;
			this.h	=	height;
		}
	}

}
