import java.io.*;
import org.kwis.msf.io.*;
import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;

public class DwInputField extends ContainerComponent { //FormComponent {
	protected Image				off_image			=	null;

	protected Image				list_title_img		=	null;
	protected Image				bottom_img		=	null;

	protected String				title				=	null;
	protected String				sub_title			=	null;
	protected String				error				=	null;
	protected String[]				button_text		=	null;

	protected _TextFieldComponent	tfc				=	null;
	protected int					rgb_color			=	0x000000;

	public DwInputField() {
		this.title				=	" ˻";
		this.sub_title			=	"ã  Է";
		this.button_text			=	new String[] { " ", "", " " };

		tfc	=	new _TextFieldComponent("", TextComponent.CONSTRAINT_ANY);
		addComponent(tfc);

		loadImage();
	}

	/**
	 * Layout Ѵ.
	 */
	public void layout() {
//		tfc.setBounds(20, 18 + 16 + 2 + 20, getWidth() - 40, 18);
		tfc.setBounds(5, 18 + 16 + 2 + 20, getWidth() - 10, 18);
	}

	/**
	 * ̹ ε...
	 */
	protected void loadImage() {
		try {
			list_title_img	=	DwData.getImage("list_title.png");
			bottom_img	=	DwData.getImage("bottom.png");

		} catch (Exception e) {
			DwCommon.Debug(e);
		}
	}

	/**
	 * TextBox Data 
	 */
	public void setData(String sub_title, String content) {
		this.sub_title	=	sub_title;
		tfc.setString(content);
		tfc.insert(new char[] { }, 0, 0, 0);

		error =	null;

		repaint();
	}

	/**
	 * TextBox ڻ 
	 */
	public void setColor(int rgb_color) {
		tfc.setForeground(rgb_color);
	}

	/**
	 * Component paintƾ...
	 * ӵ  ؼ bufferd image Ѵ.
	 */
	public void paintContent(Graphics g) {
		try {
			if(off_image == null) {
				off_image	=	Image.createImage(getWidth(), getHeight());
			}

			if(off_image != null) {
				Graphics gc	=	off_image.getGraphics();

				gc.setColor(0xffffff);
				gc.fillRect(0, 0, getWidth(), getHeight());

				drawList(gc);

				g.drawImage(off_image, 0, 0, g.TOP | g.LEFT);

				gc	=	null;
			}
		} catch (Exception e) {
			DwCommon.Debug(e);
		}

		tfc.setFocus();
	}

	/**
	 * Ʈ  ư ׸...
	 */
	public void drawList(Graphics g) {
		// ȭ ʺκп η ϴû  draw
		g.setColor(0xcdddf5);
		g.fillRect(0, 0, getWidth(), getHeight());

		// ŸƲ ̹ draw
		g.drawImage(list_title_img, 0, 0, g.TOP | g.LEFT);

		// Font  ó...
		Font old_font	=	g.getFont();
		Font new_font	=	Font.getFont(old_font.getFace(), Font.STYLE_BOLD, old_font.getSize());
		g.setFont(new_font);

		// ŸƲٿ  ǥ...
		g.setColor(0xffffff);
		g.drawString(title, 15, 1, g.TOP | g.LEFT);

		// ŸƲٿ  ǥ...
		g.setColor(0x002369);
		g.drawString(sub_title, (getWidth() - new_font.stringWidth(sub_title)) / 2, 38, g.TOP | g.LEFT);

		if(error != null) {
			g.drawString(error, (getWidth() - new_font.stringWidth(sub_title)) / 2, 80, g.TOP | g.LEFT);
		}


		int bottom_img_y	=	getHeight() - bottom_img.getHeight();

		// ȭ Ʒ ư draw
		g.drawImage(bottom_img, 0, bottom_img_y, g.TOP | g.LEFT);

		g.setFont(new_font);
		g.setColor(0xffffff);

		// ư draw
		if(button_text != null && button_text.length > 0) {
			g.drawString(button_text[0], (40 - old_font.stringWidth(button_text[0])) / 2, bottom_img_y + 5, g.TOP | g.LEFT);

			if(button_text.length == 2) {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			} else {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40, bottom_img_y + 5, g.TOP | g.LEFT);
				g.drawString(button_text[2], (40 - old_font.stringWidth(button_text[2])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			}
		}

	}

	/**
	 * Ű ̺Ʈ ó...
	 */
	public boolean keyNotify(int type, int key) {
		if(type == EventQueue.KEY_PRESSED) {
			switch(Display.getGameAction(key)) {

				case EventQueue.SOFT1 :
					setText("");
					break;

				case EventQueue.UP :
					// Ʈ ȭ ̵ ̵
					DwData.showComponent(DwData.help);
					break;

				case EventQueue.SOFT2 :
					error = null;
					searchAddress(tfc.getString());
					break;
			}
		}

		repaint();
		return false;
	}

	public void setText(String str) {
		tfc.setString(str);
		tfc.serviceRepaints();
		tfc.insert(new char[] { }, 0, 0, 0);
	}

	public class _TextFieldComponent extends TextFieldComponent {
		public _TextFieldComponent(String data, int constraints) {
			super(data, constraints);
		}

		public void setBounds(int x, int y, int width, int height) {
			this.x	=	x;
			this.y	=	y;
			this.w	=	width;
			this.h	=	height;
		}
	}

	public void searchAddress(String str) {
		if(str == null || str.length() < 1) return;

		setText(" ˻...");

		Network.connect();

		URL url			=	new URL();
		Socket sock		=	null;
		OutputStream os	=	null;
		InputStream is		=	null;

		try {
			sock		=	url.find(DwData.SERVER_STR);

			os		=	sock.getOutputStream();
			is		=	sock.getInputStream();

			DwData.sendMessage(os, DwData.SEARCH_CMD, str);

			byte[] buf	=	DwData.getNetworkData(is, DwData.COMMAND_SIZE);
			int size	=	Integer.parseInt((new String(buf)).trim());

			buf	=	DwData.getNetworkData(is, size);

			DwStringTokenizer dst	=	new DwStringTokenizer(new String(buf), DwData.DELI);

			// ̹ ˻ list .
			DwData.map_list.clearItem();


			boolean check		=	false;

			while(dst.hasMoreTokens()) {
				String token	=	dst.nextToken();
				if(token == null || token.length() < 1) continue;

				DwData.map_list.addItem(token);

				check		=	true;
			}

			if(check) {
				// Ʈ ȭ ̵ ̵
				DwData.showComponent(DwData.map_list);
			} else {
				setText("");
				error =	"  ";
			}

		} catch (Exception e) {
			DwCommon.Debug(e);
			setText("");
			error =	"Ʈũ  ";
		}

		try { is.close(); } catch (Exception e) {}
		try { os.close(); } catch (Exception e) {}
		try { sock.close(); } catch (Exception e) {}

		Network.disconnect();
	}
}
