import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;

public class DwMapList extends Component {
	public static  int			WIDTH_DIV_SIZE	=	28;

	protected Image			off_image			=	null;

	protected Image			list_title_img		=	null;
	protected Image			bottom_img		=	null;
	protected Image			up_img			=	null;
	protected Image			down_img			=	null;

	protected String			title				=	null;
	protected String[]			button_text		=	null;
	protected int				curr_pos			=	0;

	protected String[]			data				=	null;
	protected int				rgb_color			=	0x000000;

	public DwMapList() {
		this.title		=	" ˻";
		this.button_text	=	new String[] { " ", " " };
		this.data		=	null;
		this.curr_pos	=	0;

		loadImage();
	}

	protected void loadImage() {
		try {
			list_title_img	=	DwData.getImage("list_title.png");
			bottom_img	=	DwData.getImage("bottom.png");
			up_img		=	DwData.getImage("up_img.gif");
			down_img		=	DwData.getImage("down_img.gif");

		} catch (Exception e) {
			DwCommon.Debug(e);
		}
	}

	/**
	 * Ʈ ׸ Add
	 */
	public void addItem(String line) {
		data	=	DwCommon.addArray(data, line);
		repaint();
	}

	/**
	 * Ʈ ׸ clear
	 */
	public void clearItem() {
		data	=	null;
		repaint();
	}

	/**
	 * ׸ ڻ 
	 */
	public void setColor(int rgb_color) {
		this.rgb_color	=	rgb_color;
		repaint();
	}

	/**
	 * Component paintƾ...
	 * ӵ  ؼ bufferd image Ѵ.
	 */
	public void paintContent(Graphics g) {
		try {
			if(off_image == null) {
				off_image	=	Image.createImage(getWidth(), getHeight());
			}
			
			if(off_image != null) {
				Graphics gc	=	off_image.getGraphics();

				gc.setColor(0xffffff);
				gc.fillRect(0, 0, getWidth(), getHeight());

				drawList(gc);

				g.drawImage(off_image, 0, 0, g.TOP | g.LEFT);
				
				gc	=	null;
			}
		} catch (Exception e) {
			DwCommon.Debug(e);
		}

		// ̺Ʈ   ̷ Ƿ... ¿  ...paint ޼ҵ忡...
		setFocus();
	}

	/**
	 * Ʈ  ư ׸...
	 */
	public void drawList(Graphics g) {
		// ȭ ʺκп η ϴû  draw
//		g.setColor(0xcdddf5);
//		g.fillRect(0, 0, WIDTH_DIV_SIZE, getHeight());

		// ŸƲ ̹ draw
		g.drawImage(list_title_img, 0, 0, g.TOP | g.LEFT);

		// Font  ó...
		Font old_font	=	g.getFont();
		Font new_font	=	Font.getFont(old_font.getFace(), Font.STYLE_BOLD, old_font.getSize());
		g.setFont(new_font);

		// ŸƲٿ  ǥ...
		g.setColor(0xffffff);
		g.drawString(title, 15, 1, g.TOP | g.LEFT);

		// page ϱ..
		int page	=	curr_pos / 6;

		//  ϳ ׸.
		drawItem(g, old_font, page);

		int bottom_img_y	=	getHeight() - bottom_img.getHeight();

		// ȭ Ʒ ư draw
		g.drawImage(bottom_img, 0, bottom_img_y, g.TOP | g.LEFT);

		g.setFont(new_font);
		g.setColor(0xffffff);

		// ư draw
		if(button_text != null && button_text.length > 0) {
			g.drawString(button_text[0], (40 - old_font.stringWidth(button_text[0])) / 2, bottom_img_y + 5, g.TOP | g.LEFT);

			if(button_text.length == 2) {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			} else {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40, bottom_img_y + 5, g.TOP | g.LEFT);
				g.drawString(button_text[2], (40 - old_font.stringWidth(button_text[2])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			}
		}

		// ȭ鿡  ۺ  ȭǥ ǥѴ.
		if(page > 0) g.drawImage(up_img, getWidth() - 8, 19, g.TOP | g.LEFT);
		if(data != null && ((data.length - 1) / 6) != page) g.drawImage(down_img, getWidth() -8, getHeight() - 30, g.TOP | g.LEFT);
	}

	/**
	 *  ׸....(ݺ  ü...)
	 */
	public void drawItem(Graphics g, Font font, int page) {
		if(data == null || data.length < 1) return;

		g.setFont(font);

		int posY	=	20;

		for(int i=page * 6,a=0; i < data.length && a < 6; i++,a++) {
			String line		=	data[i];

			int item_posX	=	15;

			Font new_font	=	Font.getFont(font.getFace(), Font.STYLE_BOLD, font.getSize());
			g.setFont(new_font);

			if(i == curr_pos) drawSelection(g, posY - 2, font.getHeight() + 4);

			g.setColor(rgb_color);

			String str	=	"" + (i + 1);
			g.drawString(str, (item_posX - new_font.stringWidth(str)) / 2 + 1, posY, g.TOP | g.LEFT);

			g.setFont(font);
			g.drawString(line, 18, posY, g.TOP | g.LEFT);

			posY	+=	font.getHeight() + 4;
		}
	}

	/**
	 *   ġ ׸.....
	 */
	public void drawSelection(Graphics g, int posY, int height) {
		g.setColor(0xcdddf5);
		g.fillRect(0, posY, getWidth(), height);
	}

	/**
	 * Ű ̺Ʈ ó...
	 */
	public boolean keyNotify(int type, int key) {
		if(type == EventQueue.KEY_PRESSED) {
			switch(Display.getGameAction(key)) {
				case EventQueue.UP :
					curr_pos--;
					if(curr_pos < 0) curr_pos = 0;
					break;

				case EventQueue.DOWN :
					curr_pos++;
					if(curr_pos > data.length - 1) curr_pos = data.length - 1;
					break;

				// SOFT Ű Ŀ 2ۿ  Ƿ... 
				//  KeySet Ͽ óѴ. LEFT, FIRE, RIGHT
				case EventQueue.SOFT1 :
					// Ʈ ȭ ̵ ̵
					DwData.input_field.setText("");
					DwData.showComponent(DwData.input_field);
					break;

				case EventQueue.FIRE :
					break;

				case EventQueue.SOFT2 :
					// ȭ ̵ ̵
					DwData.showComponent(DwData.map_screen);
					DwData.map_screen.setSearchMap(data[curr_pos]);
					break;
			}
		}

		repaint();
		return false;
	}
}
