import java.io.*;
import org.kwis.msf.io.*;
import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;

public class DwMapScreen extends Component {
	public final static int				PER_MOVE_WIDTH	=	10;

	protected Image				off_image			=	null;

	protected Image				list_title_img		=	null;
	protected Image				bottom_img		=	null;
	protected Image				icon_img			=	null;

	protected String				title				=	null;
	protected String[]				button_text		=	null;
	protected String				alert				=	null;

	protected int					rgb_color			=	0x000000;
	protected int					posX			=	0;
	protected int					posY			=	0;

	protected Image				map				=	null;

	public DwMapScreen() {
		this.title				=	" ˻";
		this.button_text			=	new String[] { " ", " " };

		loadImage();
	}

	/**
	 * ˻ؾ Map ̸
	 */
	public void setSearchMap(String word) {
		this.posX		=	0;
		this.posY		=	0;
		this.map		=	null;

		requestMapImage(word);
	}

	/**
	 * ׸ ڻ 
	 */
	public void setColor(int rgb_color) {
		this.rgb_color	=	rgb_color;
		repaint();
	}

	/**
	 * ̹ ε...
	 */
	protected void loadImage() {
		try {
			list_title_img	=	DwData.getImage("list_title.png");
			bottom_img	=	DwData.getImage("bottom.png");
			icon_img		=	DwData.getImage("icon_map01.gif");

		} catch (Exception e) {
			DwCommon.Debug(e);
		}
	}

	/**
	 * Component paintƾ...
	 * ӵ  ؼ bufferd image Ѵ.
	 */
	public void paintContent(Graphics g) {
		try {
			if(off_image == null) {
				off_image	=	Image.createImage(getWidth(), getHeight());
			}
			
			if(off_image != null) {
				Graphics gc	=	off_image.getGraphics();

				gc.setColor(0xffffff);
				gc.fillRect(0, 0, getWidth(), getHeight());

				drawList(gc);

				g.drawImage(off_image, 0, 0, g.TOP | g.LEFT);

				gc	=	null;
			}
		} catch (Exception e) {
			DwCommon.Debug(e);
		}
	}

	/**
	 * Ʈ  ư ׸...
	 */
	public void drawList(Graphics g) {
		// ȭ ʺκп η ϴû  draw
		g.setColor(0xcdddf5);
		g.fillRect(0, 0, getWidth(), getHeight());

		// Font  ó...
		Font old_font	=	g.getFont();
		Font new_font	=	Font.getFont(old_font.getFace(), Font.STYLE_BOLD, old_font.getSize());
		g.setFont(new_font);


		if(map != null) {
			//  ׸...
			g.drawImage(map, posX * -1, posY * -1, g.TOP | g.LEFT);
	
			//  ǥ
			g.drawImage(icon_img, getWidth() - icon_img.getWidth() - 5, list_title_img.getHeight() + 5, g.TOP | g.LEFT);

		} else {
			// ŸƲٿ  ǥ...
			g.setColor(0x002369);
			g.drawString(alert, (getWidth() - new_font.stringWidth(alert)) / 2, 38, g.TOP | g.LEFT);
		}

		// ŸƲ ̹ draw
		g.drawImage(list_title_img, 0, 0, g.TOP | g.LEFT);

		// ŸƲٿ  ǥ...
		g.setColor(0xffffff);
		g.drawString(title, 15, 1, g.TOP | g.LEFT);

		int bottom_img_y	=	getHeight() - bottom_img.getHeight();

		// ȭ Ʒ ư draw
		g.drawImage(bottom_img, 0, bottom_img_y, g.TOP | g.LEFT);

		g.setFont(new_font);
		g.setColor(0xffffff);

		// ư draw
		if(button_text != null && button_text.length > 0) {
			g.drawString(button_text[0], (40 - old_font.stringWidth(button_text[0])) / 2, bottom_img_y + 5, g.TOP | g.LEFT);

			if(button_text.length == 2) {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			} else {
				g.drawString(button_text[1], (40 - old_font.stringWidth(button_text[1])) / 2 + 40, bottom_img_y + 5, g.TOP | g.LEFT);
				g.drawString(button_text[2], (40 - old_font.stringWidth(button_text[2])) / 2 + 40 * 2, bottom_img_y + 5, g.TOP | g.LEFT);
			}
		}

	}

	/**
	 * Ű ̺Ʈ ó...
	 */
	public boolean keyNotify(int type, int key) {
		if(type == EventQueue.KEY_PRESSED) {
			switch(Display.getGameAction(key)) {

				case EventQueue.LEFT :
					posX	-=	PER_MOVE_WIDTH;
					if(posX < 0) posX	=	0;

					break;

				case EventQueue.RIGHT :
					posX	+=	PER_MOVE_WIDTH;
					int size	=	map.getWidth() - getWidth();
					if(posX > size) posX	=	size;

					break;

				case EventQueue.UP :
					posY	-=	PER_MOVE_WIDTH;
					if(posY < list_title_img.getHeight() * (-1)) posY	=	list_title_img.getHeight() * (-1);

					break;

				case EventQueue.DOWN :
					posY	+=	PER_MOVE_WIDTH;
					size	=	map.getHeight() - getHeight() + bottom_img.getHeight();
					if(posY > size) posY	=	size;

					break;

				case EventQueue.SOFT1 :
					// Ʈ ȭ ̵ ̵
					DwData.showComponent(DwData.map_list);

					break;

				case EventQueue.FIRE :
					break;

				case EventQueue.SOFT2 :
					// ˻ ȭ ̵ ̵
					DwData.input_field.setText("");
					DwData.showComponent(DwData.input_field);

					break;
			}
		}

		repaint();
		return false;
	}

	public void requestMapImage(String str) {
		if(str == null || str.length() < 1) return;

		alert	=	"Map ˻!!";
		serviceRepaints();

		Network.connect();

		URL url			=	new URL();
		Socket sock		=	null;
		OutputStream os	=	null;
		InputStream is		=	null;

		try {
			sock		=	url.find(DwData.SERVER_STR);
			
			os		=	sock.getOutputStream();
			is		=	sock.getInputStream();

			DwData.sendMessage(os, DwData.MAP_CMD, str);

			byte[] buf	=	DwData.getNetworkData(is, DwData.COMMAND_SIZE);

			int size	=	Integer.parseInt((new String(buf)).trim());
			buf		=	DwData.getNetworkData(is, size);

			map		=	Image.createImage(buf, 0, buf.length);

			posX	=	(map.getWidth() - getWidth()) / 2;
			posY	=	(map.getHeight() - getHeight()) / 2 - bottom_img.getHeight();

			alert		=	null;

		} catch (Exception e) {
			DwCommon.Debug(e);

			map		=	null;
			alert		=	"Ʈũ  ";
			serviceRepaints();
		}

		try { is.close(); } catch (Exception e) {}
		try { os.close(); } catch (Exception e) {}
		try { sock.close(); } catch (Exception e) {}

		Network.disconnect();
		repaint();
	}
}
